<?php

    namespace Modules\Lpj\Http\Controllers;

    use App\Http\Controllers\Controller;
    use Exception;
    use Illuminate\Http\Request;
    use Maatwebsite\Excel\Facades\Excel;
    use Modules\Lpj\Exports\JenisJaminanExport;
    use Modules\Lpj\Http\Requests\JenisJaminanRequest;
    use Modules\Lpj\Models\JenisJaminan;
    use Modules\Lpj\Models\JenisLegalitasJaminan;

    class JenisJaminanController extends Controller
    {
        public $user;

        public function index()
        {
            return view('lpj::jenis_jaminan.index');
        }

        public function store(JenisJaminanRequest $request)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Save to database
                    JenisJaminan::create($validate);
                    return redirect()
                        ->route('basicdata.jenis-jaminan.index')
                        ->with('success', 'Jenis Jaminan created successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.jenis-jaminan.create')
                        ->with('error', 'Failed to create jenis jaminan');
                }
            }
        }

        public function create()
        {
            $jenisLegalitasJaminan = JenisLegalitasJaminan::all();
            return view('lpj::jenis_jaminan.create', compact('jenisLegalitasJaminan'));
        }

        public function edit($id)
        {
            $jenisJaminan          = JenisJaminan::find($id);
            $jenisLegalitasJaminan = JenisLegalitasJaminan::all();
            return view('lpj::jenis_jaminan.create', compact('jenisJaminan', 'jenisLegalitasJaminan'));
        }

        public function update(JenisJaminanRequest $request, $id)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Update in database
                    $jenisJaminan = JenisJaminan::find($id);
                    $jenisJaminan->update($validate);
                    return redirect()
                        ->route('basicdata.jenis-jaminan.index')
                        ->with('success', 'Jenis Jaminan updated successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.jenis-jaminan.edit', $id)
                        ->with('error', 'Failed to update jenis jaminan');
                }
            }
        }

        public function destroy($id)
        {
            try {
                // Delete from database
                $jenisJaminan = JenisJaminan::find($id);
                $jenisJaminan->delete();

                echo json_encode(['success' => true, 'message' => 'Jenis Jaminan deleted successfully']);
            } catch (Exception $e) {
                echo json_encode(['success' => false, 'message' => 'Failed to delete jenis jaminan']);
            }
        }

        public function dataForDatatables(Request $request)
        {
            if (is_null($this->user) || !$this->user->can('jenis_jaminan.view')) {
                //abort(403, 'Sorry! You are not allowed to view users.');
            }

            // Retrieve data from the database
            $query = JenisJaminan::query();

            // Apply search filter if provided
            if ($request->has('search') && !empty($request->get('search'))) {
                $search = $request->get('search');
                $query->where(function ($q) use ($search) {
                    $q->where('code', 'LIKE', "%$search%");
                    $q->orWhere('name', 'LIKE', "%$search%");
                });
            }

            // Apply sorting if provided
            if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
                $order  = $request->get('sortOrder');
                $column = $request->get('sortField');
                $query->orderBy($column, $order);
            }

            // Get the total count of records
            $totalRecords = $query->count();

            // Apply pagination if provided
            if ($request->has('page') && $request->has('size')) {
                $page   = $request->get('page');
                $size   = $request->get('size');
                $offset = ($page - 1) * $size; // Calculate the offset

                $query->skip($offset)->take($size);
            }

            // Get the filtered count of records
            $filteredRecords = $query->count();

            // Get the data for the current page
            $data = $query->get();

            // Calculate the page count
            $pageCount = ceil($totalRecords / $request->get('size'));

            // Calculate the current page number
            $currentPage = 0 + 1;

            // Return the response data as a JSON object
            return response()->json([
                'draw'            => $request->get('draw'),
                'recordsTotal'    => $totalRecords,
                'recordsFiltered' => $filteredRecords,
                'pageCount'       => $pageCount,
                'page'            => $currentPage,
                'totalCount'      => $totalRecords,
                'data'            => $data,
            ]);
        }

        public function export()
        {
            return Excel::download(new JenisJaminanExport, 'jenis_jaminan.xlsx');
        }

        public function legalitasJaminan($id)
        {
            $jenisJaminan     = JenisJaminan::find($id);
            $legalitasJaminan = $jenisJaminan->jenis_legalitas_jaminan_id;

            $legalitas = JenisLegalitasJaminan::whereIn('code', json_decode($legalitasJaminan, true))->get();
            echo json_encode($legalitas);
        }
    }
